#!/usr/bin/env perl

######################################################
# iSPY Project                                       #
# Copyright (c) 2008, Zheng Zhang, Purdue University #
######################################################

#ps ax -ww -o pid,ppid,user,command,  ax: all processes, -ww: unlimited width (so that command is not truncated)

sub Usage()
{
    print "./children.pl -k(kill) -u user -c command -p pid -h(help)\n";
}

sub GetRoots()
{
    my $lines1 = `ps ax -ww -o pid,ppid,user,command | grep "$cmd" | grep "$user"`;
    my $lines2 = `ps ax -ww -o pid,ppid,user,command | grep "$cmd" | grep "$user"`;
    #Hack, get rid of the processes belonging to $lines1 and $lines2
    my $lines = $lines1 . $lines2;
    my @psline = split (/\n/, $lines);
    for my $line (@psline) {
        if ($line =~ /^\s*(\d+)\s+(\d+)\s+.*/) {
            my ($pid) = $1;
            $process{$pid} ++;
        }
        else { next; }
    }
    
    for my $pid (keys %process) {
        $rootp{$pid} = 1 if ($process{$pid} == 2 && $pid != $$);
    }
    
    #for my $pid (keys %rootp) { print "Root $pid\n";}
}

sub TrackChild()
{
    my $lines = `ps ax -ww -o pid,ppid,user,command`;
    my @psline = split (/\n/, $lines);
    for my $line (@psline) {
        if ($line =~ /^\s*(\d+)\s+(\d+)\s+(.*)$/) {
            my ($pid, $ppid, $comm) = ($1, $2, $3);
            %{$parent{$pid}} = ( 'ppid' => $ppid, 'comment' => $comm );
            #print "Parent $pid $ppid\n";
        }
    }

    @children = (keys %rootp);
    my $cursor = 0;
    while ($cursor <= $#children) {
        #print "here cursor= $cursor, ", $children[$cursor], "\n";
        for my $pid (keys %parent) {
            push @children, $pid if $parent{$pid}{'ppid'} == $children[$cursor];
        }
        $cursor ++;
    }
    for my $childpid (@children) {
        print "$childpid ", $parent{$childpid}{'comment'}, "\n";
    }
}

use Getopt::Std;
my %opts;
getopts('u:p:c:kh', \%opts);
if ($opts{'h'}) {
    Usage(); exit (1);
}

$user = $opts{'u'} ? $opts{'u'} : "";
$cmd = $opts{'c'} ? $opts{'c'} : "";

if ($opts{'p'}) {
    $rootp{$opts{'p'}} = 1;
}
else {
    GetRoots();
}

TrackChild();
if ($opts{'k'}) {
    for my $childpid (@children) {
#        print "kill $childpid\n";
        system ("kill $childpid");
    }
}
