#!/usr/bin/env perl

######################################################
# iSPY Project                                       #
# Copyright (c) 2008, Zheng Zhang, Purdue University #
######################################################

sub resolve_ASpath($$$$$) {
    # the following args: in, out, out, out, out
    my ($text, $ippath_ref, $aspath_ref, $ret_ref, $timestamp_ref) = @_;
    
    my @lines = split('\n', $text);
    
    for (@lines) {
        if (/([^ ]+) finish_time= (\d+)/) {
            ${$ret_ref} = $1;
            ${$timestamp_ref} = $2;
        }
        elsif (/^\d/) {
#is traceroute result line
            if (/(\d+\.\d+\.\d+\.\d+) \[(.*) ms\] {(.*)}/) {
                push @{$ippath_ref}, $1;
                push @{$aspath_ref}, $3;
            }
            else {
                push @{$ippath_ref}, "*";
                push @{$aspath_ref}, "*";
            }
        }
    }
}

sub reduce_ASpath($$) {
    my ($path, $as_ref) = @_;
    my $index = 0;
    my %hops = ();
    
    for my $i (@{$path}) {
        $i = "\*(".$index.")" if $i eq "\*";
        $i = "null(".$index.")" if $i == 0;
        if (! exists $hops{$i}) {
            $hops{$i} = $index ++;
        }
        elsif ($hops{$i} < ($index - 1)) {
            #delete from $Hops{$i} to $index, make sure they are all * and null
            for my $k (keys %hops) {
                if ($hops{$k} > $hops{$i}) {
                    print STDERR "Warning: reduce_ASpath at $k, $_\n" if $k !~ /\*|null/;
                    delete $hops{$k};
                }
            }
            $index = $hops{$i} + 1; #rewind
        }
    }
    @${as_ref} = sort {$hops{$a} <=> $hops{$b}} (keys %hops);
}

#TEST
# my @t = <STDIN>;
# my (@ippath, @aspath, $ret, $time);
# resolve_ASpath(join ("", @t), \@ippath, \@aspath, \$ret, \$time);
# print "ippath: @ippath\n";
# print "aspath: @aspath\n";
# print "ret: $ret time: $time\n";
# reduce_ASpath(\@aspath, \@as);
# print "as: @as\n";
# exit(0);
