/*************************************************************/
/* iTraceroute (part of iSPY) Project                        */
/* Copyright (c) 2008, Zheng Zhang, Purdue University        */
/*************************************************************/

// PP_ttlTcp implements TCP TTL-limited probing.

#ifndef __PP_TTLTCP_H__
#define __PP_TTLTCP_H__

#include <string>
using namespace std;
#include "Common.h"
#include "PA_Traceroute.h"

class PP_ttlTcp
{
public:
    PP_ttlTcp (uint32 destIP, uint16 destPort, uint32 srcIP = 0, uint16 srcPort = 0);
                                                  //Dummyprobe if destIP==0, used for parsing packet only
                                                  //if srcPort == 0, use pid as srcPort,
                                                  //if srcIP == 0, let the routing table decide
    ~PP_ttlTcp ();
    void send (uint16 seq, uint8 ttl);
    bool parse (char* rawIpPacket, int packet_len, uint16* seq, TTL_Reply_Detail *reply_detail = NULL);
    string info_str (void);
    
private:
    void create_raw_socket (int *sockd);
    bool parse_icmp (char* rawIpPacket, int packet_len, uint16* seq, TTL_Reply_Detail *reply_detail);
    bool parse_tcp (char* rawIpPacket, int packet_len, uint16* seq, TTL_Reply_Detail *reply_detail);
    void reply_detail_code_icmp (const struct _icmphdr & icmp, TTL_Reply_Detail::Logic_Code* lc, string* nc);
        
    int sockd_;
    uint16 destPort_, srcPort_;
    uint32 destIP_, srcIP_;
};

#endif
